Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Berkeley DB Java Edition version 3.1.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.sleepycat.je
Class Database

    java.lang.Object
      com.sleepycat.je.Database

Direct Known Subclasses:
  SecondaryDatabase

    public class Database

extends Object

A database handle.

Database attributes are specified in the `DatabaseConfig` class. Database handles are free-threaded and may be used concurrently by multiple threads.

To open an existing database with default attributes:

>         Environment env = new Environment(home, null);
>         Database myDatabase = env.openDatabase(null, "mydatabase", null);

To create a transactional database that supports duplicates:

>         DatabaseConfig dbConfig = new DatabaseConfig();
>         dbConfig.setTransactional(true);
>         dbConfig.setAllowCreate(true);
>         dbConfig.setSortedDuplicates(true);
>         Database newlyCreateDb = env.openDatabase(txn, "mydatabase", dbConfig);

Method Summary
`void` | `close()` Flush any cached database information to disk and discard the database handle.
`long` | `count()` Count the key/data pairs in the database.
`OperationStatus` | `delete(Transaction txn, DatabaseEntry key)` Remove key/data pairs from the database.
`OperationStatus` | `get(Transaction txn, DatabaseEntry key, DatabaseEntry data, LockMode lockMode)` Retrieves the key/data pair with the given key.
`DatabaseConfig` | `getConfig()` Return this Database object's configuration.
`String` | `getDatabaseName()` Return the database name.
`Environment` | `getEnvironment()` Return the `Environment` handle for the database environment underlying the `Database`.
`OperationStatus` | `getSearchBoth(Transaction txn, DatabaseEntry key, DatabaseEntry data, LockMode lockMode)` Retrieves the key/data pair with the given key and data value, that is, both the key and data items must match.
`List` | `getSecondaryDatabases()` Return a list of all `SecondaryDatabase` objects associated with a primary database.
`DatabaseStats` | `getStats(StatsConfig statsConfig)` Return database statistics.
`JoinCursor` | `join(Cursor[] cursors, JoinConfig config)` Creates a specialized join cursor for use in performing equality or natural joins on secondary indices.
`Cursor` | `openCursor(Transaction txn, CursorConfig cursorConfig)` Return a cursor into the database.
`Sequence` | `openSequence(Transaction txn, DatabaseEntry key, SequenceConfig sequenceConfig)` Open a sequence in the database.
`void` | `preload(long maxBytes)` Deprecated. As of JE 2.0.83, replaced by `preload(PreloadConfig)`.
`void` | `preload(long maxBytes, long maxMillisecs)` Deprecated. As of JE 2.0.101, replaced by `preload(PreloadConfig)`.
`PreloadStats` | `preload(PreloadConfig config)` Preload the cache.
`OperationStatus` | `put(Transaction txn, DatabaseEntry key, DatabaseEntry data)` Store the key/data pair into the database.
`OperationStatus` | `putNoDupData(Transaction txn, DatabaseEntry key, DatabaseEntry data)` Store the key/data pair into the database if it does not already appear in the database.
`OperationStatus` | `putNoOverwrite(Transaction txn, DatabaseEntry key, DatabaseEntry data)` Store the key/data pair into the database if the key does not already appear in the database.
`void` | `removeSequence(Transaction txn, DatabaseEntry key)` Remove the sequence from the database.
`void` | `sync()` Flush the given database to disk; only applicable for database opened with the deferredWrite configuration option.
`int` | `truncate(Transaction txn, boolean returnCount)` Deprecated. As of JE 1.7, replaced by `Environment.truncateDatabase(Transaction, String, boolean)`. The Database class is thread safe and may be used concurrently by multiple threads, using multiple transactions. It was not possible to supply correct transactional semantics for this method in all cases without imposing a performance penalty on all operations. Specifically, a truncate operation executed within one transaction can be incorrectly seen before commit by other transactions if those later transactions use the same Database handle. The replacement method, Environment.truncateDatabase(), avoids these issues because all Database handles must be closed before the truncateDatabase() method is called.
`DatabaseStats` | `verify(VerifyConfig config)` Verify the integrity of the database.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### count

    public long count()
               throws DatabaseException

  Count the key/data pairs in the database. This operation is faster than obtaining a count from a cursor based scan of the database, and will not perturb the current contents of the cache. However, the count is not guaranteed to be accurate if there are concurrent updates.

  A count of the key/data pairs in the database is returned without adding to the cache. The count may not be accurate in the face of concurrent update operations in the database.

  Returns:
    The count of key/data pairs in the database.
  Throws:
    `DatabaseException`

### delete

    public OperationStatus delete(Transaction txn,
                                  DatabaseEntry key)
                           throws DatabaseException

  Remove key/data pairs from the database.

  The key/data pair associated with the specified key is discarded from the database. In the presence of duplicate key values, all records associated with the designated key will be discarded.

  The key/data pair is also deleted from any associated secondary databases.

  Parameters:
    `txn` - For a transactional database, an explicit transaction may be specified, or null may be specified to use auto-commit. For a non-transactional database, null must be specified.

    `key` - the key `DatabaseEntry` operated on.

  Returns:
    The method will return `OperationStatus.NOTFOUND` if the specified key is not found in the database; otherwise the method will return `OperationStatus.SUCCESS`.

  Throws:
    `DeadlockException` - if the operation was selected to resolve a deadlock.

    `DatabaseException` - if a failure occurs.

### get

    public OperationStatus get(Transaction txn,
                               DatabaseEntry key,
                               DatabaseEntry data,
                               LockMode lockMode)
                        throws DatabaseException

  Retrieves the key/data pair with the given key. If the matching key has duplicate values, the first data item in the set of duplicates is returned. Retrieval of duplicates requires the use of `Cursor` operations.

  Parameters:
    `txn` - For a transactional database, an explicit transaction may be specified to transaction-protect the operation, or null may be specified to perform the operation without transaction protection. For a non-transactional database, null must be specified.

    `key` - the key used as input. It must be initialized with a non-null byte array by the caller.

    `data` - the data returned as output. Its byte array does not need to be initialized by the caller.

    `lockMode` - the locking attributes; if null, default attributes are used.

  Returns:
    `OperationStatus.NOTFOUND` if no matching key/data pair is found; otherwise, `OperationStatus.SUCCESS`.

  Throws:
    `DeadlockException` - if the operation was selected to resolve a deadlock.

    `IllegalArgumentException` - if an invalid parameter was specified.

    `DatabaseException` - if a failure occurs.

### getSearchBoth

    public OperationStatus getSearchBoth(Transaction txn,
                                         DatabaseEntry key,
                                         DatabaseEntry data,
                                         LockMode lockMode)
                                  throws DatabaseException

  Retrieves the key/data pair with the given key and data value, that is, both the key and data items must match.

  Parameters:
    `txn` - For a transactional database, an explicit transaction may be specified to transaction-protect the operation, or null may be specified to perform the operation without transaction protection. For a non-transactional database, null must be specified.
    `key` - the key used as input. It must be initialized with a non-null byte array by the caller.
    `data` - the data used as input. It must be initialized with a non-null byte array by the caller.

    `lockMode` - the locking attributes; if null, default attributes are used.

  Returns:
    `OperationStatus.NOTFOUND` if no matching key/data pair is found; otherwise, `OperationStatus.SUCCESS`.

  Throws:
    `DeadlockException` - if the operation was selected to resolve a deadlock.

    `IllegalArgumentException` - if an invalid parameter was specified.

    `DatabaseException` - if a failure occurs.

### put

    public OperationStatus put(Transaction txn,
                               DatabaseEntry key,
                               DatabaseEntry data)
                        throws DatabaseException

  Store the key/data pair into the database.

  If the key already appears in the database and duplicates are not configured, the existing key/data pair will be replaced. If the key already appears in the database and sorted duplicates are configured, the new data value is inserted at the correct sorted location.

  Parameters:
    `txn` - For a transactional database, an explicit transaction may be specified, or null may be specified to use auto-commit. For a non-transactional database, null must be specified.

    `key` - the key `DatabaseEntry` operated on.

    `data` - the data `DatabaseEntry` stored.

  Throws:
    `DeadlockException` - if the operation was selected to resolve a deadlock.

    `DatabaseException` - if a failure occurs.

### putNoOverwrite

    public OperationStatus putNoOverwrite(Transaction txn,
                                          DatabaseEntry key,
                                          DatabaseEntry data)
                                   throws DatabaseException

  Store the key/data pair into the database if the key does not already appear in the database.

  This method will fail if the key already exists in the database, even if the database supports duplicates.

  Parameters:
    `txn` - For a transactional database, an explicit transaction may be specified, or null may be specified to use auto-commit. For a non-transactional database, null must be specified.

    `key` - the key `DatabaseEntry` operated on.

    `data` - the data `DatabaseEntry` stored.

  Returns:
    If the key already appears in the database, this method will return `OperationStatus.KEYEXIST`.

  Throws:
    `DeadlockException` - if the operation was selected to resolve a deadlock.

    `DatabaseException` - if a failure occurs.

### putNoDupData

    public OperationStatus putNoDupData(Transaction txn,
                                        DatabaseEntry key,
                                        DatabaseEntry data)
                                 throws DatabaseException

  Store the key/data pair into the database if it does not already appear in the database.

  This method may only be called if the underlying database has been configured to support sorted duplicates.

  Parameters:
    `txn` - For a transactional database, an explicit transaction may be specified, or null may be specified to use auto-commit. For a non-transactional database, null must be specified.

    `key` - the key `DatabaseEntry` operated on.

    `data` - the data `DatabaseEntry` stored.

  Returns:
    If the key/data pair already appears in the database, this method will return `OperationStatus.KEYEXIST`.

  Throws:
    `DeadlockException` - if the operation was selected to resolve a deadlock.

    `DatabaseException` - if a failure occurs.

### getDatabaseName

    public String getDatabaseName()
                           throws DatabaseException

  Return the database name.

  This method may be called at any time during the life of the application.

  Returns:
    The database name.
  Throws:
    `DatabaseException`

### getConfig

    public DatabaseConfig getConfig()
                             throws DatabaseException

  Return this Database object's configuration.

  This may differ from the configuration used to open this object if the database existed previously.

  Returns:
    This Database object's configuration.

  Throws:
    `DatabaseException` - if a failure occurs.

### getEnvironment

    public Environment getEnvironment()
                               throws DatabaseException

  Return the `Environment` handle for the database environment underlying the `Database`.

  This method may be called at any time during the life of the application.

  Returns:
    The `Environment` handle for the database environment underlying the `Database`.

  Throws:
    `DatabaseException` - if a failure occurs.

### close

    public void close()
               throws DatabaseException

  Flush any cached database information to disk and discard the database handle.

  The database handle should not be closed while any other handle that refers to it is not yet closed; for example, database handles should not be closed while cursor handles into the database remain open, or transactions that include operations on the database have not yet been committed or aborted. Specifically, this includes `Cursor` and `Transaction` handles.

  When multiple threads are using the `Database` handle concurrently, only a single thread may call this method.

  The database handle may not be accessed again after this method is called, regardless of the method's success or failure.

  When called on a database that is the primary database for a secondary index, the primary database should be closed only after all secondary indices which reference it have been closed.

  Throws:
    `DatabaseException` - if a failure occurs.

### openCursor

    public Cursor openCursor(Transaction txn,
                             CursorConfig cursorConfig)
                      throws DatabaseException

  Return a cursor into the database.

  Parameters:
    `txn` - To use a cursor for writing to a transactional database, an explicit transaction must be specified. For read-only access to a transactional database, the transaction may be null. For a non-transactional database, the transaction must be null.

    To transaction-protect cursor operations, cursors must be opened and closed within the context of a transaction, and the txn parameter specifies the transaction context in which the cursor will be used.

    `cursorConfig` - The cursor attributes. If null, default attributes are used.

  Returns:
    A database cursor.

  Throws:
    `DatabaseException` - if a failure occurs.

### sync

    public void sync()
              throws DatabaseException

  Flush the given database to disk; only applicable for database opened with the deferredWrite configuration option.

  Throws:
    `DatabaseException`

### openSequence

    public Sequence openSequence(Transaction txn,
                                 DatabaseEntry key,
                                 SequenceConfig sequenceConfig)
                          throws DatabaseException

  Open a sequence in the database.

  Parameters:
    `txn` - For a transactional database, an explicit transaction may be specified, or null may be specified to use auto-commit. For a non-transactional database, null must be specified.

    `key` - The key `DatabaseEntry` of the sequence.

    `sequenceConfig` - The sequence attributes. If null, default attributes are used.

  Returns:
    A sequence handle.

  Throws:
    `DatabaseException` - if a failure occurs.

### removeSequence

    public void removeSequence(Transaction txn,
                               DatabaseEntry key)
                        throws DatabaseException

  Remove the sequence from the database. This method should not be called if there are open handles on this sequence.

  Parameters:
    `txn` - For a transactional database, an explicit transaction may be specified, or null may be specified to use auto-commit. For a non-transactional database, null must be specified.

    `key` - The key `DatabaseEntry` of the sequence.
  Throws:
    `DatabaseException`

### getStats

    public DatabaseStats getStats(StatsConfig statsConfig)
                           throws DatabaseException

  Return database statistics.

  If this method has not been configured to avoid expensive operations (using the `StatsConfig.setFast` method), it will access some of or all the pages in the database, incurring a severe performance penalty as well as possibly flushing the underlying cache.

  In the presence of multiple threads or processes accessing an active database, the information returned by this method may be out-of-date.

  Parameters:
    `statsConfig` - The statistics returned; if null, default statistics are returned.

  Returns:
    Database statistics.

  Throws:
    `DeadlockException` - if the operation was selected to resolve a deadlock.

    `DatabaseException` - if a failure occurs.

### truncate

    public int truncate(Transaction txn,
                        boolean returnCount)
                 throws DatabaseException

  Deprecated. As of JE 1.7, replaced by `Environment.truncateDatabase(Transaction, String, boolean)`.

  The Database class is thread safe and may be used concurrently by multiple threads, using multiple transactions. It was not possible to supply correct transactional semantics for this method in all cases without imposing a performance penalty on all operations. Specifically, a truncate operation executed within one transaction can be incorrectly seen before commit by other transactions if those later transactions use the same Database handle.

  The replacement method, Environment.truncateDatabase(), avoids these issues because all Database handles must be closed before the truncateDatabase() method is called.

  Empty the database, discarding all records it contains.

  When called on a database configured with secondary indices, this method truncates the primary database and all secondary indices. If configured to return a count of the records discarded, the returned count is the count of records discarded from the primary database.

  Parameters:
    `txn` - For a transactional database, an explicit transaction may be specified, or null may be specified to use auto-commit. For a non-transactional database, null must be specified.

    `returnCount` - If true, count and return the number of records discarded.

  Returns:
    The number of records discarded, or -1 if returnCount is false.

  Throws:
    `DeadlockException` - if the operation was selected to resolve a deadlock.

    `DatabaseException` - if a failure occurs.

### join

    public JoinCursor join(Cursor[] cursors,
                           JoinConfig config)
                    throws DatabaseException

  Creates a specialized join cursor for use in performing equality or natural joins on secondary indices.

  Each cursor in the `cursors` array must have been initialized to refer to the key on which the underlying database should be joined. Typically, this initialization is done by calling `Cursor.getSearchKey`.

  Once the cursors have been passed to this method, they should not be accessed or modified until the newly created join cursor has been closed, or else inconsistent results may be returned. However, the position of the cursors will not be changed by this method or by the methods of the join cursor.

  Parameters:
    `cursors` - an array of cursors associated with this primary database.

    `config` - The join attributes. If null, default attributes are used.

  Returns:
    a specialized cursor that returns the results of the equality join operation.

  Throws:
    `DatabaseException` - if a failure occurs.
  See Also:
    `JoinCursor`

### preload

    public void preload(long maxBytes)
                 throws DatabaseException

  Deprecated. As of JE 2.0.83, replaced by `preload(PreloadConfig)`.

  Preload the cache. This method should only be called when there are no operations being performed on the database in other threads. Executing preload during concurrent updates may result in some or all of the tree being loaded into the JE cache. Executing preload during any other types of operations may result in JE exceeding its allocated cache size. preload() effectively locks the entire database and therefore will lock out the checkpointer, cleaner, and compressor, as well as not allow eviction to occur.

  Parameters:
    `maxBytes` - The maximum number of bytes to load. If maxBytes is 0, je.evictor.maxMemory is used.

  Throws:
    `DatabaseException` - if a failure occurs.

### preload

    public void preload(long maxBytes,
                        long maxMillisecs)
                 throws DatabaseException

  Deprecated. As of JE 2.0.101, replaced by `preload(PreloadConfig)`.

  Preload the cache. This method should only be called when there are no operations being performed on the database in other threads. Executing preload during concurrent updates may result in some or all of the tree being loaded into the JE cache. Executing preload during any other types of operations may result in JE exceeding its allocated cache size. preload() effectively locks the entire database and therefore will lock out the checkpointer, cleaner, and compressor, as well as not allow eviction to occur.

  Parameters:
    `maxBytes` - The maximum number of bytes to load. If maxBytes is 0, je.evictor.maxMemory is used.

    `maxMillisecs` - The maximum time in milliseconds to use when preloading. Preloading stops once this limit has been reached. If maxMillisecs is 0, preloading can go on indefinitely or until maxBytes (if non-0) is reached.

  Throws:
    `DatabaseException` - if a failure occurs.

### preload

    public PreloadStats preload(PreloadConfig config)
                         throws DatabaseException

  Preload the cache. This method should only be called when there are no operations being performed on the database in other threads. Executing preload during concurrent updates may result in some or all of the tree being loaded into the JE cache. Executing preload during any other types of operations may result in JE exceeding its allocated cache size. preload() effectively locks the entire database and therefore will lock out the checkpointer, cleaner, and compressor, as well as not allow eviction to occur.

  Parameters:
    `config` - The PreloadConfig object that specifies the parameters of the preload.

  Returns:
    A PreloadStats object with various statistics about the preload() operation.

  Throws:
    `DatabaseException` - if a failure occurs.

### verify

    public DatabaseStats verify(VerifyConfig config)
                         throws DatabaseException

  Verify the integrity of the database.

  Verification is an expensive operation that should normally only be used for troubleshooting and debugging.

  Parameters:
    `config` - Configures the verify operation; if null, the default operation is performed.

  Returns:
    Database statistics.

  Throws:
    `IllegalArgumentException` - if an invalid parameter was specified.

    `DatabaseException` - if a failure occurs.

### getSecondaryDatabases

    public List getSecondaryDatabases()
                               throws DatabaseException

  Return a list of all `SecondaryDatabase` objects associated with a primary database.

  If no secondaries are associated or this is itself a secondary database, an empty list is returned.

  Returns:
    A list of all `SecondaryDatabase` objects associated with a primary database.
  Throws:
    `DatabaseException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Berkeley DB Java Edition version 3.1.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright(c) 1996-2006 Oracle Corporation - All rights reserved.